# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_with repolib

%define reltag %{nil}
%define namedreltag %{nil}
%global namedversion %{version}%{?namedreltag}

Name:           objectweb-asm
Version:        3.3.1
Release:        8%{?reltag}%{?dist}
Epoch:          0
Summary:        Code manipulation tool to implement adaptable systems
License:        BSD
URL:            http://asm.objectweb.org/
Group:          Development/Java
Source0:        http://download.forge.objectweb.org/asm/asm-%{version}.tar.gz
Source1:        asm-%{version}.pom
Source2:        asm-analysis-%{version}.pom
Source3:        asm-commons-%{version}.pom
Source4:        asm-tree-%{version}.pom
Source5:        asm-util-%{version}.pom
Source6:        asm-xml-%{version}.pom
Source7:        asm-all-%{version}.pom
Source8:        asm-parent-%{version}.pom
Source9:        asm-MANIFEST.MF
Source10:       asm-debug-all-%{version}.pom
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
# Needed by asm-xml.jar
BuildRequires:  ant >= 0:1.7
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils
BuildRequires:  objectweb-anttask
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  jboss-parent
BuildRequires:  zip
%if %with repolib
BuildRequires:  maven2-plugin-deploy
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
ASM is a code manipulation tool to implement adaptable systems.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
Javadoc for %{name}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n asm-%{version}
perl -pi -e 's/\r$//g' LICENSE.txt README.txt

mkdir META-INF
cp -p %{SOURCE9} META-INF/MANIFEST.MF

%build
export CLASSPATH=
export OPT_JAR_LIST=:
%{ant} -Dobjectweb.ant.tasks.path=$(build-classpath objectweb-anttask) jar jdoc

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}/%{name}

for jar in output/dist/lib/*.jar; do
    cp -p ${jar} %{buildroot}%{_javadir}/%{name}/`basename ${jar}`
done

touch META-INF/MANIFEST.MF
zip -q -u output/dist/lib/all/asm-all-%{version}.jar META-INF/MANIFEST.MF

cp -p output/dist/lib/all/asm-all-%{version}.jar %{buildroot}%{_javadir}/%{name}/
cp -p output/dist/lib/all/asm-debug-all-%{version}.jar %{buildroot}%{_javadir}/%{name}/

(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{version}*; do mv ${jar} ${jar/-%{version}/-%{namedversion}}; done)
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do ln -s ${jar} ${jar/-%{namedversion}/}; done)

# pom
mkdir -p %{buildroot}%{_mavenpomdir}
cp -p %{SOURCE1} %{buildroot}%{_mavenpomdir}/JPP.%{name}-asm.pom
cp -p %{SOURCE2} %{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-analysis.pom
cp -p %{SOURCE3} %{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-commons.pom
cp -p %{SOURCE4} %{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-tree.pom
cp -p %{SOURCE5} %{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-util.pom
cp -p %{SOURCE6} %{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-xml.pom
cp -p %{SOURCE7} %{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-all.pom
cp -p %{SOURCE8} %{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-parent.pom
cp -p %{SOURCE10} %{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-debug-all.pom

# depmaps
%add_to_maven_depmap asm asm %{namedversion} JPP/%{name} asm
%add_to_maven_depmap asm asm-analysis %{namedversion} JPP/%{name} asm-analysis
%add_to_maven_depmap asm asm-commons %{namedversion} JPP/%{name} asm-commons
%add_to_maven_depmap asm asm-tree %{namedversion} JPP/%{name} asm-tree
%add_to_maven_depmap asm asm-util %{namedversion} JPP/%{name} asm-util
%add_to_maven_depmap asm asm-xml %{namedversion} JPP/%{name} asm-xml
%add_to_maven_depmap asm asm-all %{namedversion} JPP/%{name} asm-all
%add_to_maven_depmap asm asm-parent %{namedversion} JPP/%{name} asm-parent
%add_to_maven_depmap asm asm-debug-all %{namedversion} JPP/%{name} asm-debug-all
# FIXME: need to get rid of these, but bad poms still exist
%add_to_maven_depmap org.objectweb.asm asm %{namedversion} JPP/%{name} asm
%add_to_maven_depmap org.objectweb.asm asm-analysis %{namedversion} JPP/%{name} asm-analysis
%add_to_maven_depmap org.objectweb.asm asm-commons %{namedversion} JPP/%{name} asm-commons
%add_to_maven_depmap org.objectweb.asm asm-tree %{namedversion} JPP/%{name} asm-tree
%add_to_maven_depmap org.objectweb.asm asm-util %{namedversion} JPP/%{name} asm-util
%add_to_maven_depmap org.objectweb.asm asm-xml %{namedversion} JPP/%{name} asm-xml
%add_to_maven_depmap org.objectweb.asm asm-all %{namedversion} JPP/%{name} asm-all
%add_to_maven_depmap org.objectweb.asm asm-parent %{namedversion} JPP/%{name} asm-parent
%add_to_maven_depmap org.objectweb.asm asm-debug-all %{namedversion} JPP/%{name} asm-debug-all

# javadoc
install -p -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
cp -pr output/dist/doc/javadoc/user/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
ln -s %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_mavenpomdir}/JPP.%{name}-asm.pom -Dfile=%{buildroot}%{_javadir}/%{name}/asm-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-analysis.pom -Dfile=%{buildroot}%{_javadir}/%{name}/asm-analysis-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-commons.pom -Dfile=%{buildroot}%{_javadir}/%{name}/asm-commons-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-tree.pom -Dfile=%{buildroot}%{_javadir}/%{name}/asm-tree-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-util.pom -Dfile=%{buildroot}%{_javadir}/%{name}/asm-util-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-xml.pom -Dfile=%{buildroot}%{_javadir}/%{name}/asm-xml-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-all.pom -Dfile=%{buildroot}%{_javadir}/%{name}/asm-all-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -Dfile=%{buildroot}%{_mavenpomdir}/JPP.%{name}-asm-parent.pom -DgroupId=org.objectweb.asm -DartifactId=asm-parent -Dpackaging=pom -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt README.txt
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/asm-%{namedversion}.jar
%{_javadir}/%{name}/asm-all-%{namedversion}.jar
%{_javadir}/%{name}/asm-all.jar
%{_javadir}/%{name}/asm-analysis-%{namedversion}.jar
%{_javadir}/%{name}/asm-analysis.jar
%{_javadir}/%{name}/asm-commons-%{namedversion}.jar
%{_javadir}/%{name}/asm-commons.jar
%{_javadir}/%{name}/asm-debug-all-%{namedversion}.jar
%{_javadir}/%{name}/asm-debug-all.jar
%{_javadir}/%{name}/asm-tree-%{namedversion}.jar
%{_javadir}/%{name}/asm-tree.jar
%{_javadir}/%{name}/asm-util-%{namedversion}.jar
%{_javadir}/%{name}/asm-util.jar
%{_javadir}/%{name}/asm-xml-%{namedversion}.jar
%{_javadir}/%{name}/asm-xml.jar
%{_javadir}/%{name}/asm.jar
%{_mavenpomdir}/JPP.%{name}-asm-all.pom
%{_mavenpomdir}/JPP.%{name}-asm-analysis.pom
%{_mavenpomdir}/JPP.%{name}-asm-commons.pom
%{_mavenpomdir}/JPP.%{name}-asm-debug-all.pom
%{_mavenpomdir}/JPP.%{name}-asm-parent.pom
%{_mavenpomdir}/JPP.%{name}-asm-tree.pom
%{_mavenpomdir}/JPP.%{name}-asm-util.pom
%{_mavenpomdir}/JPP.%{name}-asm-xml.pom
%{_mavenpomdir}/JPP.%{name}-asm.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Mon Dec 17 2012 David Walluck <dwalluck@redhat.com> 0:3.3.1-8
- put back bad depmaps due to bad poms which still contain the dependency

* Fri Dec 14 2012 David Walluck <dwalluck@redhat.com> 0:3.3.1-7
- fix install of poms

* Fri Dec 14 2012 David Walluck <dwalluck@redhat.com> 0:3.3.1-6
- don't install bad depmap entries which have no corresponding poms
- don't use vman poms
- use _mavenpomdir macro

* Tue Feb 14 2012 Fernando Nasser <fnasser@redhat.com> 0:3.3.1-5._redhat_1.1
- Do not require JAXP at run-time (provided)

* Thu Dec 29 2011 Yong Yang <yyang@redhat.com> 0:3.3.1-4.4_redhat_1
- Fix version in repolib, use full name jars

* Thu Dec 29 2011 Yong Yang <yyang@redhat.com> 0:3.3.1-4.3_redhat_1
- Build for Werewolf

* Tue Sep 13 2011 Yong Yang <yyang@redhat.com> 0:3.3.1-4.2
- Fix typo {version} in repolib

* Mon Jun 27 2011 David Walluck <dwalluck@redhat.com> 0:3.3.1-4.1
- fix POM names
- add repolib
- update file list

* Sat Jun 25 2011 David Walluck <dwalluck@redhat.com> 0:3.3.1-4
- keep the asm groupId

* Mon Apr 04 2011 David Walluck <dwalluck@redhat.com> 0:3.3.1-3
- fix file list

* Mon Apr 04 2011 David Walluck <dwalluck@redhat.com> 0:3.3.1-2
- fix maven depmaps
- don't own maven2 poms dir
- use explicit file list
- really install asm-debug-all jar

* Sat Feb 12 2011 David Walluck <dwalluck@redhat.com> 0:3.3.1-1
- 3.3.1
- include asm-debug-all

* Wed Oct 06 2010 Ralph Apel <r.apel@r-apel.de> 0:3.2-2
- Fix groupId in added poms

* Fri Sep 24 2010 Ralph Apel <r.apel@r-apel.de> 0:3.2-1
- 3.2

* Tue Oct 23 2008 David Walluck <dwalluck@redhat.com> 0:3.1-5
- add OSGi manifest (Alexander Kurtakov)

* Mon Oct 20 2008 David Walluck <dwalluck@redhat.com> 0:3.1-4
- remove Class-Path from MANIFEST.MF
- add unversioned javadoc symlink
- remove javadoc scriptlets
- fix directory ownership
- remove build requirement on dos2unix

* Fri Feb 08 2008 Ralph Apel <r.apel@r-apel.de> - 0:3.1-3jpp
- Add poms and depmap frags with groupId of org.objectweb.asm !
- Add asm-all.jar 
- Add -javadoc Requires post and postun
- Restore Vendor, Distribution

* Thu Nov 22 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.1-2jpp
- Fix EOL of txt files
- Add dependency on jaxp 

* Thu Nov 22 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.1-1jpp
- Upgrade to 3.1

* Wed Aug 22 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.0-1jpp
- Upgrade to 3.0
- Rename to include objectweb- prefix as requested by ObjectWeb

* Thu Jan 05 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.1-2jpp
- First JPP 1.7 build

* Thu Oct 06 2005 Ralph Apel <r.apel at r-apel.de> 0:2.1-1jpp
- Upgrade to 2.1

* Fri Mar 11 2005 Sebastiano Vigna <vigna at acm.org> 0:2.0.RC1-1jpp
- First release of the 2.0 line.
